#include "console.h"

#ifndef LINUX_USED
int IsConsole = 0;
HANDLE hOutput = INVALID_HANDLE_VALUE, hInput = INVALID_HANDLE_VALUE;

void console_write(char ** args)
{
	char buf [128];		// Suppose, only one line to print.
	DWORD d;

	console_open(); // if you use console_write(), console opens automatically.

	WriteConsole(hOutput, buf, wvsprintf(buf, *args, (va_list)(args+1)), &d, NULL);
}
#endif

void console_write_str(char *str, int len)
{
#ifndef LINUX_USED
	DWORD d;
	console_open(); // if you use console_write(), console opens automatically.
	WriteConsole(hOutput, str, len, &d, NULL);
#else
	printf("%s", str);
#endif
}

#ifndef LINUX_USED
void console_write(char * msg, ...)
{
	console_write(&msg);
}
#endif

int console_read(char *buf, int NumChars)
{
#ifndef LINUX_USED
	DWORD d;

	SetConsoleMode(hInput, ENABLE_LINE_INPUT | ENABLE_ECHO_INPUT | ENABLE_PROCESSED_INPUT );
	ReadConsole(hInput, buf, NumChars, &d, NULL);
	if (d > 2) buf [d-=2] = 0;
	else buf [d] = 0;

	return (int) d;
#else
	scanf("%s", buf);
	return strlen(buf);
#endif
}

int console_read_char()
{
#ifndef LINUX_USED
	DWORD d;
	int buf = 0;

	SetConsoleMode(hInput, ENABLE_PROCESSED_INPUT);
	ReadConsole(hInput, &buf, 1, &d, NULL);

	return buf;
#else
	return getch();
#endif
}

#ifndef LINUX_USED
void console_open()
{	
	if (!IsConsole) 
	{
		//Error(!AllocConsole(), "Create console");
		AllocConsole();
		IsConsole = 1;
		hOutput = GetStdHandle(STD_OUTPUT_HANDLE);
		Error(hOutput == INVALID_HANDLE_VALUE, "Output");
		hInput = GetStdHandle(STD_INPUT_HANDLE);
		Error(hInput == INVALID_HANDLE_VALUE, "Input");
	}
}

void console_close()
{
	FreeConsole();
	IsConsole = 0;
}
#endif

#if defined(APP_OPT_DEBUG) || defined(APP_OPT_DEBUG_RUN)
void console_log(char * msg, ...)
{
#ifndef LINUX_USED
	console_write(&msg);
#else
	vprintf(msg, (va_list)(&msg+1));
#endif
	console_write("\n");
}
#endif

