#include "file_io.h"

int file_io_open(char * filename, char access)
{
#ifndef LINUX_USED
	register HANDLE hFile = CreateFile(filename,
		(access == 'r')?GENERIC_READ:((access == 'w')?GENERIC_WRITE:(GENERIC_READ|GENERIC_WRITE) ),
		(access == 'r')?FILE_SHARE_READ:0,
		NULL, (access == 'w')?CREATE_ALWAYS:OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

	Error(hFile == INVALID_HANDLE_VALUE, IDS_OPEN_FILE, filename);
#else
	char acs [2] = { access, 0 };
	register FILE *hFile = fopen(filename, acs);
	Error(!hFile, IDS_OPEN_FILE, filename);
#endif

	return (int) hFile;
}

void file_io_close(int handle)
{
#ifndef LINUX_USED
	CloseHandle((HANDLE) handle);
#else
	fclose((FILE *) handle);
#endif
}

int file_io_get_char(int file)
{
#ifndef LINUX_USED
	int chr = 0;
	DWORD d;

	Error(!ReadFile((HANDLE) file, &chr, 1, &d, NULL), IDS_READ_FILE_CHAR);

	if (d == 0) chr = -1;
	return chr;
#else
	return fgetc((FILE *) file);
#endif
}

/*int file_io_get_size(int file)
{
	return (int) GetFileSize((HANDLE) file, NULL);
}*/

void file_io_write(int file, void *buf, int size)
{
#ifndef LINUX_USED
	DWORD d;
	Error(!WriteFile((HANDLE) file, buf, size, &d, NULL), IDS_CANT_WRITE_FILE);
#else
	fwrite(buf, size, 1, (FILE *) file);
#endif
}

