/// INCLUDED FILE, NOT STANDING ALONE ///

/*** LOAD STD ATOMS ***/

atom_s * __fastcall register_extern(char * name, void *adr)
{
	register atom_s *p = atoms_add(name);
	p->set_flag(atom_info_external | atom_info_function);
	p->body = (list_s *) adr;
	return p;
}

void __fastcall set_init_var(atom_s *var_name, char *var_value)
{
	register list_s **ptr = &(list_add(&(std_atom_initialize->body), std_atom_set)->sublist);
	list_push(ptr, atoms_add(var_value));
	list_push(ptr, var_name);
}

static const struct { atom_s **var; char *name; void *func; } ALL_ATOMS [] =
{
	&std_atom_write,		"write",		(void*) atol_write,
	&std_atom_writenl,		"writenl",		(void*) atol_writenl,
	&std_atom_writeln,		"writeln",		(void*) atol_writenl,
	&std_atom_nl,			"nl",			(void*) atol_nl,

	&std_atom_eol,			"eol",			(void*) atol_eol,

	&std_atom_read,			"read",			(void*) atol_read,
	&std_atom_readchar,		"readchar",		(void*) atol_readchar,

	&std_atom_if,			"if",			(void*) atol_if,
	&std_atom_with,			"with",			(void*) atol_with,

	&std_atom_trace,		"trace",		(void*) atol_trace,
	&std_atom_notrace,		"notrace",		(void*) atol_notrace,
	&std_atom_spy,			"spy",			(void*) atol_spy,

	&std_atom_eq,			"eq",			(void*) atol_eq,
	&std_atom_eqi,			"eqi",			(void*) atol_eqi,
	&std_atom_eqf,			"eqf",			(void*) atol_eqf,
	&std_atom_at,			"at",			(void*) atol_at,

	&std_atom_gettag,		"get_tag",		(void*) atol_gettag,
	&std_atom_settag,		"set_tag",		(void*) atol_settag,

	&std_atom_body,			BODY_STR,		(void*) atol_body,
	&std_atom_set,			"set",			(void*) atol_set,
	&std_atom_var,			"var",			(void*) atol_var,
	&std_atom_g_var,		"g_var",		(void*) atol_g_var,
	&std_atom_new,			"new",			(void*) atol_new,
	&std_atom_g_new,		"g_new",		(void*) atol_g_new,

	&std_atom_append,		"append",		(void*) atol_append,
	&std_atom_concat,		"concat",		(void*) atol_concat,
	&std_atom_left,			"left",			(void*) atol_left,
	&std_atom_right,		"right",		(void*) atol_right,
	&std_atom_middle,		"middle",		(void*) atol_middle,
	&std_atom_length,		"length",		(void*) atol_length,
	&std_atom_reverse,		"reverse",		(void*) atol_reverse,
	&std_atom_head,			"head",			(void*) atol_head,
	&std_atom_tail,			"tail",			(void*) atol_tail,
	&std_atom_last,			"last",			(void*) atol_last,
	&std_atom_like,			"like",			(void*) atol_like,

	&std_atom_not,			"not",			(void*) atol_not,
	&std_atom_and,			"and",			(void*) atol_and,
	&std_atom_or,			"or",			(void*) atol_or,

	&std_atom_return,		"return",		(void*) atol_return,
	&std_atom_assert,		"assert",		(void*) atol_assert,
	&std_atom_NULL,			"null",			(void*) atol_null,

	&std_atom_eval,			"eval",			(void*) atol_eval,
	&std_atom_include,		"include",		(void*) atol_include,

	&std_atom_call,			"call",			(void*) atol_call,

	&std_atom_rnd,			"rnd",			(void*) atol_rnd,
	&std_atom_shell,		"shell",		(void*) atol_shell,
	&std_atom_sleep,		"sleep",		(void*) atol_sleep,

	&std_atom_version,		"atol.version",		(void*) atol_version,
	&std_atom_about,		"atol.about",		(void*) atol_about,
	&std_atom_gettime,		"get_time",		(void*) atol_gettime,
	&std_atom_atom_num,		"atol.number_of_atoms", (void*) atol_atom_num

};

static const struct { atom_s **var; char *name; } JUST_ATOMS [] =
{
	&std_atom_null,			"",
	&std_atom_true,		 	"true",
	&std_atom_main,			"main",
	&std_atom_mark,			MARK_STR,
	&std_atom_else,		    "else",
	&std_atom_class,		"class",
	&std_atom_initialize,	"atol.initialize",
	&std_atom_do,			"do",
	&std_atom_EOL,			"\r\n",
	&std_atom_cmd_line,		"command_line",
	&std_atom_rnd_set,		"rnd.symbols"
};


void load_std_atoms()
{
#ifdef APP_OPT_DEBUG
	console_log(">LOAD STD ATOMS");
#endif

	// register just atoms
	register int i;
	for (i = 0; i < sizeof(JUST_ATOMS)/sizeof(JUST_ATOMS[0]); ++i)
		*(JUST_ATOMS [i] .var) = atoms_add(JUST_ATOMS [i] .name);

	// register std functions.
	for (i = 0; i < sizeof(ALL_ATOMS)/sizeof(ALL_ATOMS[0]); ++i)
		*(ALL_ATOMS [i] .var) = register_extern(ALL_ATOMS [i] .name, ALL_ATOMS [i] .func);

	// set some flags:
	std_atom_initialize->set_flag(atom_info_function);

	// --- ADD SOME CODE INTO ATOL.INITIALIZE: ---
	register list_s **ptr = &(list_add(&(std_atom_initialize->body), std_atom_g_var)->sublist);

	list_push(ptr, std_atom_cmd_line);
	list_push(ptr, std_atom_rnd_set);
	list_push(ptr, atoms_add("_"));		// noname-variable.

	set_init_var(std_atom_cmd_line, GetCommandLine());
	set_init_var(std_atom_rnd_set, "0123456789");


#ifdef APP_OPT_DEBUG
	console_log(">END");
#endif
}
